﻿'http://www.vb-magazin.de/forums/forums/p/5464/21352.aspx

Public Class Form2
    Private SpaltenBreiten As New List(Of Single)   ' Auflistung mit der Breite der einzelnen Spalten

    Private TextHöhe As Single
    Private DruckSpalte As Integer
    Private DruckZeile As Integer
    Private DGVSpaltenIndex As Integer
    Private DGVZeilenIndex As Integer
    Private DGVDruckbreite As Single
    Private ZellPadding As Integer = 5
    Private Querformat As Boolean = True

    Public HeaderColor As System.Drawing.Color = Color.LightGray
    Public RowColor As System.Drawing.Color = Color.White
    Public RowColorAlternate As System.Drawing.Color = Color.LightYellow
    Public HZentrieren As Boolean = True
    Public DruckeGitternetzlinien As Boolean = True
    Public SpaltenAutoSize As Boolean = False

    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i As Integer = 1 To 50
            dgv_Tabelle.Rows.Add("Peter", "Punkt-Maier", i)
        Next

        dgv_Tabelle.AllowUserToAddRows = False          ' Für Testzwecke

        PrintDoc.DefaultPageSettings.Landscape = Not Querformat
    End Sub

    Private Sub btn_Drucken_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Drucken.Click
        SpaltenBreitenErmitteln()
        PrintDoc.Print()
    End Sub

    Private Sub btn_Vorschau_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Vorschau.Click
        SpaltenBreitenErmitteln()

        Using dlg As New System.Windows.Forms.PrintPreviewDialog
            dlg.Document = PrintDoc
            dlg.WindowState = FormWindowState.Maximized
            dlg.ShowDialog()
        End Using
    End Sub

    Sub SpaltenBreitenErmitteln()
        Dim ZellInhalt As String
        Dim Breite As Single = 0
        Dim g As Graphics = dgv_Tabelle.CreateGraphics

        SpaltenBreiten.Clear()
        DGVDruckbreite = 0

        If SpaltenAutoSize = True Then
            For DGVSpalte As Integer = 0 To dgv_Tabelle.Columns.Count - 1

                ' *** Breite das Textes im Spaltenkopf als Mindestbreite
                ZellInhalt = dgv_Tabelle.Columns(DGVSpalte).HeaderText
                Breite = g.MeasureString(ZellInhalt, dgv_Tabelle.Font).Width + ZellPadding
                SpaltenBreiten.Add(Breite)

                ' *** Jede Spalte komplett durchlaufen und größte Textbreite finden und speichern
                For DGVZeile As Integer = 0 To dgv_Tabelle.Rows.Count - 1
                    ' Zellinhalt holen und ggf. formatieren
                    ZellInhalt = dgv_Tabelle.Rows(DGVZeile).Cells(DGVSpalte).Value.ToString
                    If dgv_Tabelle.Columns(DGVSpalte).DefaultCellStyle.Format.ToString <> String.Empty Then
                        ZellInhalt = CDbl(ZellInhalt).ToString(dgv_Tabelle.Columns(DGVSpalte).DefaultCellStyle.Format.ToString)
                    End If
                    ' Spaltenbreite feststellen und prüfen, ob größer als bisher und ggf. austauschen
                    Breite = g.MeasureString(ZellInhalt, dgv_Tabelle.Font).Width + ZellPadding
                    If SpaltenBreiten(DGVSpalte) < Breite Then
                        SpaltenBreiten(DGVSpalte) = Breite
                    End If
                    DGVDruckbreite += Breite
                Next

            Next
        Else                                                            ' Kein SpaltenAutoSizing
            For DGVSpalte As Integer = 0 To dgv_Tabelle.Columns.Count - 1
                Breite = dgv_Tabelle.Columns(DGVSpalte).Width + ZellPadding
                SpaltenBreiten.Add(Breite)
                DGVDruckbreite += Breite
            Next
        End If

    End Sub

    Sub PrintDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDoc.PrintPage
        Dim ZellBox As New RectangleF
        Dim sf As New StringFormat

        Dim LRand As Single 'Decimal
        Dim RRand As Single 'Decimal
        Dim ROben As Single 'Decimal
        Dim RUnten As Single 'Decimal

        Dim PageWidth As Integer
        Dim PageHeight As Decimal

        Dim dgv_MaxZeilenIndex As Integer
        Dim dgv_MaxSpaltenIndex As Integer
        'Dim dgv_Breite As Integer

        Dim ZellInhalt As String
        Dim PosX As Integer
        Dim PosY As Integer
        Dim PosX1 As Integer

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias

        ' *****
        ' * Höhe der Schrift ermitteln anhand der Schriftart(Font)
        ' * mittels Mustertext (mit Ober- und Unterlängen)
        ' * und Höhe geringfügig erhöhen
        ' *****

        Dim g As Graphics = dgv_Tabelle.CreateGraphics
        TextHöhe = g.MeasureString("Bg", dgv_Tabelle.Font).Height + ZellPadding ' Mustertext zur Ermittlung der Schrifthöhe

        With PrintDoc.DefaultPageSettings
            LRand = .Margins.Left                           ' Rand links
            RRand = .Margins.Right                          ' Rand rechts
            ROben = .Margins.Top                            ' Rand oben
            RUnten = .Margins.Bottom                        ' Rand unten

            PageWidth = .Bounds.Width - CInt(RRand + LRand)     ' Druckbereich Breite
            PageHeight = .Bounds.Height - CInt(ROben + RUnten)  ' Druckbereich Höhe

            e.Graphics.DrawRectangle(Pens.Black, LRand, ROben, PageWidth, PageHeight) ' Rahmen um alles
        End With


        PosY = CInt(ROben)

        If HZentrieren = True Then              ' Tabelle horizontal zentrieren
            LRand = CSng(LRand + (PageWidth / 2)) - (DGVDruckbreite / 2)
        End If

        PosX = CInt(LRand)

        ' * Den höchsten ZeilenIndex des DataGridview ermitteln
        ' * in Abhängigkeit davon, ob ein Zeile am Ende steht
        If dgv_Tabelle.AllowUserToAddRows = True Then
            dgv_MaxZeilenIndex = dgv_Tabelle.Rows.Count - 2
        Else
            dgv_MaxZeilenIndex = dgv_Tabelle.Rows.Count - 1
        End If

        dgv_MaxSpaltenIndex = dgv_Tabelle.Columns.Count - 1

        sf.Alignment = StringAlignment.Near
        sf.LineAlignment = StringAlignment.Center

        ' ***** Spaltenköpfe drucken
        DruckSpalte = 0
        Do
            ZellBox = New RectangleF(PosX, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)
            ZellInhalt = dgv_Tabelle.Columns(DruckSpalte).HeaderText

            e.Graphics.FillRectangle(New SolidBrush(HeaderColor), ZellBox)
            If DruckeGitternetzlinien = True Then
                e.Graphics.DrawRectangle(Pens.Black, ZellBox.X, ZellBox.Y, ZellBox.Width, ZellBox.Height)
            End If
            e.Graphics.DrawString(ZellInhalt, dgv_Tabelle.Font, Brushes.Black, ZellBox, sf)

            PosX += CInt(SpaltenBreiten(DruckSpalte))
            DruckSpalte += 1
        Loop Until DruckSpalte > dgv_MaxSpaltenIndex

        ' ***** Zeileninhalte drucken

        DruckZeile = 0
        PosX = CInt(LRand)
        PosY = CInt(ROben + TextHöhe)

        Do
            DruckSpalte = 0
            Do
                ZellInhalt = dgv_Tabelle.Rows(DruckZeile + DGVZeilenIndex).Cells(DruckSpalte).Value.ToString
                ZellBox = New RectangleF(PosX, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)

                If dgv_Tabelle.Columns(DruckSpalte).DefaultCellStyle.Format.ToString <> String.Empty Then
                    ZellInhalt = CDbl(ZellInhalt).ToString(dgv_Tabelle.Columns(DruckSpalte).DefaultCellStyle.Format.ToString)
                End If

                If (DGVZeilenIndex + DruckZeile) Mod 2 = 0 Then ' Zeilen abwechselnd einfärben
                    e.Graphics.FillRectangle(New SolidBrush(RowColor), ZellBox)
                Else
                    e.Graphics.FillRectangle(New SolidBrush(RowColorAlternate), ZellBox)
                End If

                If DruckeGitternetzlinien = True Then
                    e.Graphics.DrawRectangle(Pens.Black, ZellBox.X, ZellBox.Y, ZellBox.Width, ZellBox.Height)
                End If

                Select Case dgv_Tabelle.Columns(DruckSpalte).DefaultCellStyle.Alignment.ToString
                    Case "NotSet", "MiddleLeft"
                        ZellBox = New RectangleF(PosX, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)

                    Case "MiddleRight"
                        PosX1 = CInt(PosX + SpaltenBreiten(DruckSpalte) - (g.MeasureString(ZellInhalt, dgv_Tabelle.Font).Width))
                        ZellBox = New RectangleF(PosX1, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)

                    Case "MiddleCenter"
                        PosX1 = CInt(PosX + (SpaltenBreiten(DruckSpalte) / 2) - (g.MeasureString(ZellInhalt, dgv_Tabelle.Font).Width / 2))
                        ZellBox = New RectangleF(PosX1, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)

                    Case Else
                        ZellBox = New RectangleF(PosX, PosY, SpaltenBreiten(DruckSpalte), TextHöhe)

                End Select
                e.Graphics.DrawString(ZellInhalt, dgv_Tabelle.Font, Brushes.Black, ZellBox, sf)

                PosX += CInt(SpaltenBreiten(DruckSpalte))
                DruckSpalte += 1

            Loop Until (DruckSpalte > dgv_MaxSpaltenIndex)

            PosX = CInt(LRand)
            PosY += CInt(TextHöhe)
            DruckZeile += 1
        Loop Until ((DruckZeile + DGVZeilenIndex) > (dgv_MaxZeilenIndex)) _
                                    OrElse ((PageHeight + ROben) < PosY + TextHöhe)

        If (DruckZeile + DGVZeilenIndex) > (dgv_MaxZeilenIndex) Then
            e.HasMorePages = False
            DGVZeilenIndex = 0
            DruckSpalte = 0
            DruckZeile = 0
            Exit Sub
        Else
            e.HasMorePages = True
            DGVZeilenIndex = DruckZeile + DGVZeilenIndex
            Exit Sub
        End If

    End Sub

End Class